Index: trunk/source/physics_lists/builders/src/G4BertiniPionBuilder.cc
===================================================================
--- trunk/source/physics_lists/builders/src/G4BertiniPionBuilder.cc	(revision 1350)
+++ trunk/source/physics_lists/builders/src/G4BertiniPionBuilder.cc	(revision 1350)
@@ -0,0 +1,80 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+// $Id: G4BertiniPionBuilder.cc,v 1.1 2010/11/19 16:21:40 gunter Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
+//
+//---------------------------------------------------------------------------
+//
+// ClassName:   G4BertiniPionBuilder
+//
+// Author: 2010 G.Folger
+//  devired from G4BertiniPiKBuilder
+//
+// Modified:
+// 02.04.2009 V.Ivanchenko remove add cross section, string builderis reponsible 
+//
+//----------------------------------------------------------------------------
+//
+#include "G4BertiniPionBuilder.hh"
+#include "G4ParticleDefinition.hh"
+#include "G4ParticleTable.hh"
+#include "G4ProcessManager.hh"
+
+G4BertiniPionBuilder::
+G4BertiniPionBuilder() 
+ {
+   thePiData = new G4PiNuclearCrossSection;
+   theMin = 0*GeV;
+   theMax = 9.9*GeV;
+   theModel = new G4CascadeInterface;
+   theModel->SetMinEnergy(theMin);
+   theModel->SetMaxEnergy(theMax); 
+ }
+
+G4BertiniPionBuilder::~G4BertiniPionBuilder() 
+{
+}
+
+void G4BertiniPionBuilder::
+Build(G4PionPlusInelasticProcess * aP)
+ {
+   aP->RegisterMe(theModel);
+   theModel->SetMinEnergy(theMin);
+   theModel->SetMaxEnergy(theMax);
+ }
+
+void G4BertiniPionBuilder::
+Build(G4PionMinusInelasticProcess * aP)
+ {
+   aP->RegisterMe(theModel);
+   theModel->SetMinEnergy(theMin);
+   theModel->SetMaxEnergy(theMax);
+ }
+
+void G4BertiniPionBuilder::
+Build(G4HadronElasticProcess * ) {}
+
+         
Index: trunk/source/physics_lists/builders/src/G4ChipsKaonBuilder.cc
===================================================================
--- trunk/source/physics_lists/builders/src/G4ChipsKaonBuilder.cc	(revision 1350)
+++ trunk/source/physics_lists/builders/src/G4ChipsKaonBuilder.cc	(revision 1350)
@@ -0,0 +1,82 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
+//
+//---------------------------------------------------------------------------
+//
+// Author: 2010 G.Folger
+//  devired from G4LEPPiKBuilder
+//
+//
+// Modified:
+//
+//----------------------------------------------------------------------------
+//
+#include "G4ChipsKaonBuilder.hh"
+
+#include "globals.hh"
+#include "G4ios.hh"
+#include "G4MesonConstructor.hh"
+#include "G4ProcessManager.hh"
+
+G4ChipsKaonBuilder::G4ChipsKaonBuilder(G4int ver)
+  : verb(ver)
+{
+  theInelastic = new G4QInelastic();
+}
+
+G4ChipsKaonBuilder::
+~G4ChipsKaonBuilder() 
+{
+  delete theInelastic;
+}
+
+void G4ChipsKaonBuilder::Build()
+{
+     static G4bool onceOnly(true);
+     if ( onceOnly )
+     {
+	if (verb > 0 ) 
+	  {G4cout << "Info - G4ChipsKaonBuilder::Build() not adding elastic" <<
+                      G4endl;}
+
+	attachProcess(G4KaonPlus::KaonPlus());
+	attachProcess(G4KaonMinus::KaonMinus());
+	attachProcess(G4KaonZeroShort::KaonZeroShort());
+	attachProcess(G4KaonZeroLong::KaonZeroLong());
+        onceOnly=false;
+     }
+}
+
+void G4ChipsKaonBuilder::attachProcess(G4ParticleDefinition * pDef)
+{
+     if ( verb > 0 ) {
+        G4cout << " Using G4Qinelastic for " << pDef->GetParticleName()
+	      << G4endl; 
+     }
+     G4ProcessManager* pMan = pDef->GetProcessManager();
+     pMan->AddDiscreteProcess(theInelastic);
+}
Index: trunk/source/physics_lists/builders/src/G4HadronElasticPhysics93.cc
===================================================================
--- trunk/source/physics_lists/builders/src/G4HadronElasticPhysics93.cc	(revision 1350)
+++ trunk/source/physics_lists/builders/src/G4HadronElasticPhysics93.cc	(revision 1350)
@@ -0,0 +1,241 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+// $Id: G4HadronElasticPhysics93.cc,v 1.1 2010/07/29 10:52:14 vnivanch Exp $
+// GEANT4 tag $Name: phys-lists-V09-03-34 $
+//
+//---------------------------------------------------------------------------
+//
+// ClassName:   G4HadronElasticPhysics93
+//
+// Author: 11 April 2006 V. Ivanchenko
+//
+// Modified:
+// 05.07.2006 V.Ivanchenko define process by particle name; 
+//                         fix problem of initialisation of HP
+// 24.07.2006 V.Ivanchenko add G4NeutronHPElasticData 
+// 10.08.2006 V.Ivanchenko separate neutrons from other particles
+// 17.11.2006 V.Ivanchenko do not redefine G4HadronElastic default parameters
+// 19.02.2007 V.Ivanchenko set QModelLowLimit and LowestEnergyLimit to zero
+// 19.02.2007 A.Howard set QModelLowLimit and LowestEnergyLimit to zero 
+//                     for neutrons
+// 06.03.2007 V.Ivanchenko use updated interface to G4UElasticCrossSection
+//
+//----------------------------------------------------------------------------
+//
+
+#include "G4HadronElasticPhysics93.hh"
+
+#include "G4HadronicProcess.hh"
+#include "G4HadronElasticProcess.hh"
+#include "G4HadronicInteraction.hh"
+#include "G4LElastic.hh"
+
+#include "G4ParticleDefinition.hh"
+#include "G4ProcessManager.hh"
+
+#include "G4MesonConstructor.hh"
+#include "G4BaryonConstructor.hh"
+#include "G4IonConstructor.hh"
+#include "G4Neutron.hh"
+
+#include "G4VQCrossSection.hh"
+#include "G4UElasticCrossSection.hh"
+#include "G4BGGNucleonElasticXS.hh"
+#include "G4BGGPionElasticXS.hh"
+
+G4HadronElasticPhysics93::G4HadronElasticPhysics93(G4int ver)
+  : G4VPhysicsConstructor("elastic"), mname("elastic"),verbose(ver),
+    hpFlag(false), glFlag(false),wasActivated(false)
+{
+  if(verbose > 1) G4cout << "### HadronElasticPhysics93" << G4endl;
+  model = 0;
+  neutronModel = 0;
+  neutronHPModel = 0;  
+}
+
+G4HadronElasticPhysics93::G4HadronElasticPhysics93(
+    const G4String& name,  G4int ver, G4bool hp, G4bool glauber)
+  : G4VPhysicsConstructor(name), mname(name), verbose(ver), hpFlag(hp), 
+    glFlag(glauber),wasActivated(false)
+{
+  if(verbose > 1) G4cout << "### HadronElasticPhysics93" << G4endl;
+  model = 0;
+  neutronModel = 0;
+  neutronHPModel = 0;  
+}
+
+G4HadronElasticPhysics93::~G4HadronElasticPhysics93()
+{
+  delete model;
+  delete neutronModel;
+  delete neutronHPModel;
+}
+
+void G4HadronElasticPhysics93::ConstructParticle()
+{
+// G4cout << "G4HadronElasticPhysics93::ConstructParticle" << G4endl;
+  G4MesonConstructor pMesonConstructor;
+  pMesonConstructor.ConstructParticle();
+
+  G4BaryonConstructor pBaryonConstructor;
+  pBaryonConstructor.ConstructParticle();
+
+  //  Construct light ions
+  G4IonConstructor pConstructor;
+  pConstructor.ConstructParticle();  
+}
+
+void G4HadronElasticPhysics93::ConstructProcess()
+{
+  if(wasActivated) return;
+  wasActivated = true;
+
+  if(verbose > 1) {
+    G4cout << "### HadronElasticPhysics93 Construct Processes with the model <" 
+	   << mname << ">" << G4endl;
+  }
+  G4HadronicProcess* hel = 0;
+  G4VQCrossSection* man = 0; 
+
+  if(mname == "elastic") {
+    G4HadronElastic* he = new G4HadronElastic();
+    model = he;
+    man = he->GetCS();
+    he->SetQModelLowLimit(0.0);
+    he->SetLowestEnergyLimit(0.0);
+  } else {
+    model = new G4LElastic();
+  }
+
+  theParticleIterator->reset();
+  while( (*theParticleIterator)() )
+  {
+    G4ParticleDefinition* particle = theParticleIterator->value();
+    G4ProcessManager* pmanager = particle->GetProcessManager();
+    G4String pname = particle->GetParticleName();
+    if(pname == "anti_lambda"  ||
+       pname == "anti_neutron" ||
+       pname == "anti_omega-"  || 
+       pname == "anti_proton"  || 
+       pname == "anti_sigma-"  || 
+       pname == "anti_sigma+"  || 
+       pname == "anti_xi-"  || 
+       pname == "anti_xi0"  || 
+       pname == "kaon-"     || 
+       pname == "kaon+"     || 
+       pname == "kaon0S"    || 
+       pname == "kaon0L"    || 
+       pname == "lambda"    || 
+       pname == "omega-"    || 
+       pname == "sigma-"    || 
+       pname == "sigma+"    || 
+       pname == "xi-"       || 
+       pname == "alpha"     ||
+       pname == "deuteron"  ||
+       pname == "triton") {
+      
+      if(mname == "elastic") {
+	G4UHadronElasticProcess* h = new G4UHadronElasticProcess("hElastic");
+	h->SetQElasticCrossSection(man);
+        hel = h;
+        if(glFlag) hel->AddDataSet(new G4UElasticCrossSection(particle));
+      } else {                   
+	hel = new G4HadronElasticProcess("hElastic");
+      }
+      hel->RegisterMe(model);
+      pmanager->AddDiscreteProcess(hel);
+      if(verbose > 1)
+	G4cout << "### HadronElasticPhysics93 added for " 
+	       << particle->GetParticleName() << G4endl;
+
+      // proton case
+    } else if(pname == "proton") {
+      if(mname == "elastic") {
+	G4UHadronElasticProcess* h = new G4UHadronElasticProcess("hElastic");
+	h->SetQElasticCrossSection(man);
+        hel = h;
+        if(glFlag) hel->AddDataSet(new G4BGGNucleonElasticXS(particle));
+      } else {                   
+	hel = new G4HadronElasticProcess("hElastic");
+      }
+      hel->RegisterMe(model);
+      pmanager->AddDiscreteProcess(hel);
+      if(verbose > 1)
+	G4cout << "### HadronElasticPhysics93 added for " 
+	       << particle->GetParticleName() << G4endl;
+
+      // neutron case
+    } else if(pname == "neutron") {   
+
+      if(mname == "elastic") {
+	G4UHadronElasticProcess* h = new G4UHadronElasticProcess("hElastic");
+	G4HadronElastic* nhe = new G4HadronElastic();
+	nhe->SetQModelLowLimit(0.0);
+	nhe->SetLowestEnergyLimit(0.0);
+	neutronModel = nhe;
+	h->SetQElasticCrossSection(nhe->GetCS());
+        hel = h;
+        if(glFlag) hel->AddDataSet(new G4BGGNucleonElasticXS(particle));
+      } else {                   
+	hel = new G4HadronElasticProcess("hElastic");
+	neutronModel = new G4LElastic();
+      }
+
+      if(hpFlag) {
+	neutronModel->SetMinEnergy(19.5*MeV);
+	neutronHPModel = new G4NeutronHPElastic();
+	hel->RegisterMe(neutronHPModel);
+	hel->AddDataSet(new G4NeutronHPElasticData());
+      }
+
+      hel->RegisterMe(neutronModel);
+      pmanager->AddDiscreteProcess(hel);
+
+      if(verbose > 1)
+	G4cout << "### HadronElasticPhysics93 added for " 
+	       << particle->GetParticleName() << G4endl;
+
+      // pion case
+    } else if(pname == "pi+" || pname == "pi-") {
+      if(mname == "elastic") {
+	G4UHadronElasticProcess* h = new G4UHadronElasticProcess("hElastic");
+	h->SetQElasticCrossSection(man);
+        hel = h;
+        if(glFlag) hel->AddDataSet(new G4BGGPionElasticXS(particle));
+      } else {                   
+	hel = new G4HadronElasticProcess("hElastic");
+      }
+      hel->RegisterMe(model);
+      pmanager->AddDiscreteProcess(hel);
+
+      if(verbose > 1)
+	G4cout << "### HadronElasticPhysics93 added for " 
+	       << particle->GetParticleName() << G4endl;
+    }
+  }
+}
+
+
Index: trunk/source/physics_lists/builders/src/G4KaonBuilder.cc
===================================================================
--- trunk/source/physics_lists/builders/src/G4KaonBuilder.cc	(revision 1350)
+++ trunk/source/physics_lists/builders/src/G4KaonBuilder.cc	(revision 1350)
@@ -0,0 +1,88 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+// $Id: G4KaonBuilder.cc,v 1.1 2010/11/19 16:21:40 gunter Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
+//
+//---------------------------------------------------------------------------
+//
+// ClassName:   G4KaonBuilder
+//
+// Author: 2010 G.Folger
+//  devired from G4PiKBuilder
+//
+// Modified:
+//
+//----------------------------------------------------------------------------
+//
+#include "G4KaonBuilder.hh"
+#include "G4ParticleDefinition.hh"
+#include "G4ParticleTable.hh"
+#include "G4ProcessManager.hh"
+
+G4KaonBuilder::
+G4KaonBuilder(): wasActivated(false) 
+{  
+  theKaonPlusInelastic=new G4KaonPlusInelasticProcess;
+  theKaonMinusInelastic=new G4KaonMinusInelasticProcess;
+  theKaonZeroLInelastic=new G4KaonZeroLInelasticProcess;
+  theKaonZeroSInelastic=new G4KaonZeroSInelasticProcess;
+}
+
+G4KaonBuilder::
+~G4KaonBuilder(){
+  delete theKaonPlusInelastic;
+  delete theKaonMinusInelastic;
+  delete theKaonZeroLInelastic;
+  delete theKaonZeroSInelastic;
+}
+
+void G4KaonBuilder::
+Build()
+{
+  wasActivated = true;
+
+  std::vector<G4VKaonBuilder *>::iterator i;
+  for(i=theModelCollections.begin(); i!=theModelCollections.end(); i++)
+  {
+    (*i)->Build(theKaonPlusInelastic);
+    (*i)->Build(theKaonMinusInelastic);
+    (*i)->Build(theKaonZeroLInelastic);
+    (*i)->Build(theKaonZeroSInelastic);
+  }
+  G4ProcessManager * theProcMan;
+ 
+  theProcMan = G4KaonPlus::KaonPlus()->GetProcessManager();
+  theProcMan->AddDiscreteProcess(theKaonPlusInelastic);
+  
+  theProcMan = G4KaonMinus::KaonMinus()->GetProcessManager();
+  theProcMan->AddDiscreteProcess(theKaonMinusInelastic);
+  
+  theProcMan = G4KaonZeroLong::KaonZeroLong()->GetProcessManager();
+  theProcMan->AddDiscreteProcess(theKaonZeroLInelastic);
+  
+  theProcMan = G4KaonZeroShort::KaonZeroShort()->GetProcessManager();
+  theProcMan->AddDiscreteProcess(theKaonZeroSInelastic);
+}
Index: trunk/source/physics_lists/builders/src/G4LEPPionBuilder.cc
===================================================================
--- trunk/source/physics_lists/builders/src/G4LEPPionBuilder.cc	(revision 1350)
+++ trunk/source/physics_lists/builders/src/G4LEPPionBuilder.cc	(revision 1350)
@@ -0,0 +1,84 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
+//
+//---------------------------------------------------------------------------
+//
+// ClassName:   G4LEPPionBuilder
+//
+// Author: 2010 G.Folger
+//  devired from G4LEPPiKBuilder
+//
+// Modified:
+//
+//----------------------------------------------------------------------------
+//
+#include "G4LEPPionBuilder.hh"
+
+#include "globals.hh"
+#include "G4ios.hh"
+#include "G4ParticleDefinition.hh"
+#include "G4ParticleTable.hh"
+#include "G4MesonConstructor.hh"
+#include "G4BaryonConstructor.hh"
+#include "G4ProcessManager.hh"
+
+G4LEPPionBuilder::
+G4LEPPionBuilder()  
+{
+  theMin = 0;
+  theMax = 55*GeV;
+}
+
+G4LEPPionBuilder::
+~G4LEPPionBuilder() 
+{
+  delete theLEPionPlusModel;
+}
+
+void G4LEPPionBuilder::
+Build(G4HadronElasticProcess *)
+{
+    G4cout << "Info - G4LEPPionBuilder::Build() not adding elastic" << G4endl;
+}
+
+void G4LEPPionBuilder::
+Build(G4PionPlusInelasticProcess * aP)
+{
+  theLEPionPlusModel = new G4LEPionPlusInelastic();
+  theLEPionPlusModel->SetMinEnergy(theMin);
+  theLEPionPlusModel->SetMaxEnergy(theMax);
+  aP->RegisterMe(theLEPionPlusModel);
+}
+
+void G4LEPPionBuilder::
+Build(G4PionMinusInelasticProcess * aP)
+{
+  theLEPionMinusModel = new G4LEPionMinusInelastic();
+  theLEPionMinusModel->SetMinEnergy(theMin);
+  theLEPionMinusModel->SetMaxEnergy(theMax);
+  aP->RegisterMe(theLEPionMinusModel);
+}
Index: trunk/source/physics_lists/builders/src/G4PionBuilder.cc
===================================================================
--- trunk/source/physics_lists/builders/src/G4PionBuilder.cc	(revision 1350)
+++ trunk/source/physics_lists/builders/src/G4PionBuilder.cc	(revision 1350)
@@ -0,0 +1,76 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+// $Id: G4PionBuilder.cc,v 1.1 2010/11/19 16:21:40 gunter Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
+//
+//---------------------------------------------------------------------------
+//
+// ClassName:   G4PionBuilder
+//
+// Author: 2010 G.Folger
+//  devired from G4PiKBuilder
+//
+// Modified:
+//
+//----------------------------------------------------------------------------
+//
+#include "G4PionBuilder.hh"
+#include "G4ParticleDefinition.hh"
+#include "G4ParticleTable.hh"
+#include "G4ProcessManager.hh"
+
+G4PionBuilder::
+G4PionBuilder(): wasActivated(false) 
+{  
+  thePionPlusInelastic=new G4PionPlusInelasticProcess;
+  thePionMinusInelastic=new G4PionMinusInelasticProcess;
+}
+
+G4PionBuilder::
+~G4PionBuilder(){
+  delete thePionPlusInelastic;
+  delete thePionMinusInelastic;
+}
+
+void G4PionBuilder::
+Build()
+{
+  wasActivated = true;
+
+  std::vector<G4VPionBuilder *>::iterator i;
+  for(i=theModelCollections.begin(); i!=theModelCollections.end(); i++)
+  {
+    (*i)->Build(thePionPlusInelastic);
+    (*i)->Build(thePionMinusInelastic);
+  }
+  G4ProcessManager * theProcMan;
+
+  theProcMan = G4PionPlus::PionPlus()->GetProcessManager();
+  theProcMan->AddDiscreteProcess(thePionPlusInelastic);
+  
+  theProcMan = G4PionMinus::PionMinus()->GetProcessManager();
+  theProcMan->AddDiscreteProcess(thePionMinusInelastic);
+}
Index: trunk/source/physics_lists/builders/src/G4QGSPPionBuilder.cc
===================================================================
--- trunk/source/physics_lists/builders/src/G4QGSPPionBuilder.cc	(revision 1350)
+++ trunk/source/physics_lists/builders/src/G4QGSPPionBuilder.cc	(revision 1350)
@@ -0,0 +1,119 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+// $Id: G4QGSPPionBuilder.cc,v 1.1 2010/11/19 16:21:40 gunter Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
+//
+//---------------------------------------------------------------------------
+//
+// ClassName:   G4QGSPPionBuilder
+//
+// Author: 2010 G.Folger
+//  devired from G4QGSPPiKBuilder
+//
+// Modified:
+// 17.11.2010 G.Folger, use G4CrossSectionPairGG for relativistic rise of cross
+//             section at high energies.
+// 30.03.2009 V.Ivanchenko create cross section by new
+//
+//----------------------------------------------------------------------------
+//
+#include "G4QGSPPionBuilder.hh"
+#include "G4ParticleDefinition.hh"
+#include "G4ParticleTable.hh"
+#include "G4ProcessManager.hh"
+#include "G4PiNuclearCrossSection.hh"
+#include "G4CrossSectionPairGG.hh"
+
+G4QGSPPionBuilder::
+G4QGSPPionBuilder(G4bool quasiElastic, G4bool projectileDiffraction) 
+{
+  thePiData = new G4CrossSectionPairGG(new G4PiNuclearCrossSection(), 91*GeV);
+  theMin = 12*GeV;
+  theModel = new G4TheoFSGenerator("QGSP");
+
+  theStringModel = new G4QGSModel< G4QGSParticipants >;
+  theStringDecay = new G4ExcitedStringDecay(theQGSM = new G4QGSMFragmentation);
+  theStringModel->SetFragmentationModel(theStringDecay);
+  
+
+  theCascade = new G4GeneratorPrecompoundInterface;
+  thePreEquilib = new G4PreCompoundModel(theHandler = new G4ExcitationHandler);
+  theCascade->SetDeExcitation(thePreEquilib);  
+
+  theModel->SetHighEnergyGenerator(theStringModel);
+  if (quasiElastic)
+  {
+     theQuasiElastic=new G4QuasiElasticChannel;
+     theModel->SetQuasiElasticChannel(theQuasiElastic);
+  } else 
+  {  theQuasiElastic=0;}
+  if ( projectileDiffraction )
+  {
+     theProjectileDiffraction=new G4ProjectileDiffractiveChannel;
+     theModel->SetProjectileDiffraction(theProjectileDiffraction);
+  } else 
+  {  theProjectileDiffraction=0;}
+   
+  theModel->SetTransport(theCascade);
+}
+ 
+G4QGSPPionBuilder::
+~G4QGSPPionBuilder() 
+{
+  delete theCascade;
+  delete thePreEquilib;
+  if ( theQuasiElastic ) delete theQuasiElastic;
+  if ( theProjectileDiffraction ) delete theProjectileDiffraction;
+  delete theStringDecay;
+  delete theStringModel;
+  delete theModel;
+  delete theQGSM;
+  delete theHandler;
+}
+
+void G4QGSPPionBuilder::
+Build(G4HadronElasticProcess * ) {}
+
+void G4QGSPPionBuilder::
+Build(G4PionPlusInelasticProcess * aP)
+{
+  theModel->SetMinEnergy(theMin);
+  theModel->SetMaxEnergy(100*TeV);
+  aP->AddDataSet(thePiData);
+  aP->RegisterMe(theModel);
+}
+
+void G4QGSPPionBuilder::
+Build(G4PionMinusInelasticProcess * aP)
+{
+  theModel->SetMinEnergy(theMin);
+  theModel->SetMaxEnergy(100*TeV);
+  aP->AddDataSet(thePiData);
+  aP->RegisterMe(theModel);
+}
+
+
+// 2002 by J.P. Wellisch
Index: trunk/source/physics_lists/builders/src/G4VKaonBuilder.cc
===================================================================
--- trunk/source/physics_lists/builders/src/G4VKaonBuilder.cc	(revision 1350)
+++ trunk/source/physics_lists/builders/src/G4VKaonBuilder.cc	(revision 1350)
@@ -0,0 +1,46 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+// $Id: G4VKaonBuilder.cc,v 1.1 2010/11/19 16:21:40 gunter Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
+//
+//---------------------------------------------------------------------------
+//
+// ClassName:   G4VKaonBuilder
+//
+// Author: 2010 G.Folger
+//  devired from G4VPiKBuilder
+//
+// Modified:
+//
+//----------------------------------------------------------------------------
+//
+#include "G4VKaonBuilder.hh"
+
+G4VKaonBuilder::G4VKaonBuilder() 
+{}
+
+G4VKaonBuilder::~G4VKaonBuilder() 
+{}
Index: trunk/source/physics_lists/builders/src/G4VPionBuilder.cc
===================================================================
--- trunk/source/physics_lists/builders/src/G4VPionBuilder.cc	(revision 1350)
+++ trunk/source/physics_lists/builders/src/G4VPionBuilder.cc	(revision 1350)
@@ -0,0 +1,46 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+// $Id: G4VPionBuilder.cc,v 1.1 2010/11/19 16:21:40 gunter Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
+//
+//---------------------------------------------------------------------------
+//
+// ClassName:   G4VPionBuilder
+//
+// Author: 2010 G.Folger
+//  devired from G4VPiKBuilder
+//
+// Modified:
+//
+//----------------------------------------------------------------------------
+//
+#include "G4VPionBuilder.hh"
+
+G4VPionBuilder::G4VPionBuilder() 
+{}
+
+G4VPionBuilder::~G4VPionBuilder() 
+{}
